package de.swirtz.sekurity.api

import de.swirtz.sekurity.core.ProviderConfiguration
import de.swirtz.sekurity.core.TLSSocketFactoryProvider

val defaultTLSProtocols = listOf("TLSv1.2")

typealias DSLConfig = ProviderConfiguration.() -> Unit
/**
 * To be used for creating [SSLServerSocketFactory] instances by using the Sekurity DSL
 */
fun serverSocketFactory(protocols: List<String> = defaultTLSProtocols, configuration: DSLConfig = {}) =
        with(TLSSocketFactoryProvider(configuration)) {
            this.createServerSocketFactory(protocols)
        }

/**
 * To be used for creating [SSLSocketFactory] instances by using the Sekurity DSL
 */
fun socketFactory(protocols: List<String> = defaultTLSProtocols, configuration: DSLConfig = {}) =
        with(TLSSocketFactoryProvider(configuration)) {
            this.createSocketFactory(protocols)
        }

fun main(args: Array<String>) {
    var charAr = Array(5) { ' ' }
    for (i in 0..4) {
        println("Please Enter the character Number ${i + 1}")
        charAr[i] = readLine()?.get(0) ?: throw IllegalArgumentException()
    }
}
